//---------------------------------------------------------------------------

#include <vcl.h>
#include <iostream>
#include <iterator>
#include <vector>
#include <algorithm>

#include <conio.h> //  getch()

#pragma hdrstop

//---------------------------------------------------------------------------

#pragma argsused
using namespace std;


std::string ToRus(const std::string &in)
{
  char *buff = new char [in.length()+1];
  CharToOem(in.c_str(),buff);
  std::string out(buff);
  delete [] buff;
  return out;
}

template <class T>
inline void PRINT_ELEMENTS (const T& coll, const char* optcstr="")
{
  typename T::const_iterator pos;
  std::cout << ToRus(optcstr);
  for (pos=coll.begin(); pos!=coll.end(); ++pos) {
    std::cout <<*pos <<' ';
  }
  std::cout << std::endl;
}


//      
class MeanValue {
  private:
    long num;    //  
    long sum;    //    
  public:
    // 
    MeanValue () : num(0), sum(0) {
    }

    // " "
    // -    
    void operator() (int elem) {
        num++;          //  
        sum += elem;    //  
    }

    //   
    double value () {
        return static_cast<double>(sum) / static_cast<double>(num);
    }
};


int main(int argc, char* argv[])
{
  vector<int> coll;

  //    1  8
  for (int i=1; i<=8; ++i) {
      coll.push_back(i);
  }
  PRINT_ELEMENTS(coll," :\n");

  //     
  MeanValue mv = for_each (coll.begin(), coll.end(),  // 
                           MeanValue());              // 
  cout << ToRus(" : ") << mv.value() << endl;

  getch();
  return 0;
}

//---------------------------------------------------------------------------